<?php

namespace EnumType;

/**
 * This class stands for CampaignSort EnumType
 * @subpackage Enumerations
 */
class CampaignSort
{
    /**
     * Constant for value 'ID'
     * @return string 'ID'
     */
    const VALUE_ID = 'ID';
    /**
     * Constant for value 'name'
     * @return string 'name'
     */
    const VALUE_NAME = 'name';
    /**
     * Constant for value 'startDate'
     * @return string 'startDate'
     */
    const VALUE_START_DATE = 'startDate';
    /**
     * Constant for value 'stopDate'
     * @return string 'stopDate'
     */
    const VALUE_STOP_DATE = 'stopDate';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_ID
     * @uses self::VALUE_NAME
     * @uses self::VALUE_START_DATE
     * @uses self::VALUE_STOP_DATE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ID,
            self::VALUE_NAME,
            self::VALUE_START_DATE,
            self::VALUE_STOP_DATE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
